<template>
  <div style="margin-top:auto; display:flex; /* flex-direction:row; align-items:stretch; */">
    <textarea v-model="out" style="flex:1; height:200px" spellcheck="false" />
  </div>
</template>

<script>

const fs = require('fs')
const yaml = require('js-yaml')

export default {
  name:  'exporter',
  props: {
    root: {
      type:     String,
      required: true,
    },
  },
  data () {
    return {
      out:      {},
      rendered: {},
    }
  },

  // computed: {
  //   out () {
  //     return JSON.stringify(yaml)
  //   },
  // },

  // watch: {
  //   out (value) {
  //     // console.log('neu: '+val)
  //     // this.$emit('input', value)
  //   },
  // },

  created () {
    [ this.rendered,, this.out ] = this.render(this.root, {})
  },

  methods: {
    render (path, imports) {
      try {
        if (!fs.existsSync(path)) {
          console.log('No such file:', path)
          return '[]'
        }
        const raw = fs.readFileSync(path, 'utf8')
        const data = yaml.safeLoad(raw)
        // console.log('yaml', data)
        if (data && data.hasOwnProperty('a')) {
          // let path = data.a
          // [, imports] = this.render(data.a, imports)
          // [path, data.a] = [data.a, ]
          // imports[path] = data.a // the new data a
        }
        return [data, imports, raw]
      } catch (e) {
        console.error(e)
        return []
      }
    },
  },
}
</script>

<style scoped>

</style>
